﻿using System;
using System.Text;
using System.IO;
using NUnit.Framework;

namespace Calculator
{

    [TestFixture()]
    public class ConsoleCalculatorTest
    {
        private string testInput;
        private string testOutput;
        private static string NEW_LINE = Environment.NewLine;

        [Test()]
        public void TestConsoleOperation()
        {
            testInput = "10" + NEW_LINE 
                    + "5" + NEW_LINE 
                    + "+" + NEW_LINE 
                    + "evaluate" + NEW_LINE 
                    + "print" + NEW_LINE 
                    + "quit" + NEW_LINE;
            testOutput = "#####15" + NEW_LINE 
                    + "#Console calculator quitting..." + NEW_LINE;

            StringReader reader = new StringReader(testInput);
            StringBuilder builder = new StringBuilder();
            StringWriter writer = new StringWriter(builder);

            //<-- You may change the following 4 lines to adapt to your design.
            ReversePolishNotationCalculator calc = new ReversePolishNotationCalculator();	// Model
            CalculatorConsole cons = new CalculatorConsole(reader, writer, calc);			// View
            CalculatorController contr = new CalculatorController(calc, cons);				// Controller
            cons.Run();
            //-->

            reader.Close();
            writer.Close();

            Assert.That(builder.ToString().Equals(testOutput), "Fail");
        }

        [Test()]
        public void TestConsoleLanguage()
        {
            testInput = "deutsch" + NEW_LINE
                    + "10" + NEW_LINE
                    + "5" + NEW_LINE
                    + "+" + NEW_LINE
                    + "auswerten" + NEW_LINE
                    + "drucken" + NEW_LINE
                    + "Hilfe" + NEW_LINE
                    + "english" + NEW_LINE
                    + "help" + NEW_LINE
                    + "quit" + NEW_LINE;
            testOutput = "#Aktuelle Sprache: deutsch" + NEW_LINE
                    + "Befehle: loeschen, drucken, beenden, hilfe, auswerten" + NEW_LINE
                    + "#####15" + NEW_LINE
                    + "#Ungueltige Eingabe:" + NEW_LINE
                    + "\tHilfe" + NEW_LINE
                    + "#Current language: english" + NEW_LINE
                    + "Available commands: clear, print, quit, help, evaluate" + NEW_LINE
                    + "#Available commands: clear, print, quit, help, evaluate" + NEW_LINE
                    + "#Console calculator quitting..." + NEW_LINE;

            StringReader reader = new StringReader(testInput);
            StringBuilder builder = new StringBuilder();
            StringWriter writer = new StringWriter(builder);

            //<-- You may change the following 4 lines to adapt to your design.
            ReversePolishNotationCalculator calc = new ReversePolishNotationCalculator();	// Model
            CalculatorConsole cons = new CalculatorConsole(reader, writer, calc);			// View
            CalculatorController contr = new CalculatorController(calc, cons);				// Controller
            cons.Run();
            //-->

            reader.Close();
            writer.Close();

            Assert.That(builder.ToString().Equals(testOutput), "Fail");
        }

    }
}
